<!DOCTYPE html>
<html lang="en">
<head>
  <title>${customer_project} issues report</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="css/bootstrap.min.css">
  <link rel="stylesheet" href="css/dc.css">
  <script src="js/jquery-3.4.1.min.js"></script>
  <script src="js/bootstrap.min.js"></script>
  <script src="js/d3.v6.min.js"></script>
  <script src="js/crossfilter.js"></script>
  <script src="js/dc.js"></script>
  <style>
    .dc-chart g.row text {
       fill: black;  
     }

     #cycle-time-opened {
        background: rgb(198, 219, 239);
        width: 170px;
        font-size: 64px;
        text-align: center;
        padding-top: 63px;
        padding-bottom: 63px;
        height: 170px;
        line-height: normal;
        margin: 10px ;
        position: relative;
      }

     #cycle-time-logged {
        background: rgb(107, 174, 214);
        width: 170px;
        font-size: 64px;
        text-align: center;
        padding-top: 63px;
        padding-bottom: 63px;
        height: 170px;
        line-height: normal;
        margin: 10px ;
        position: relative;
      }

    .number-display {
      position: absolute;
      top: 50%;
      margin: 0;
      transform: translate(0, -50%);
      margin-left: auto;
      margin-right: auto;
      display: block;
      width: 170px;
    
    }
  </style>
  <script type="text/javascript">
    d3.json('./customer_issues_flat.json').then(function(data) {

      const dateFormatSpecifier = '%Y-%m-%d';
      const dateFormat = d3.timeFormat(dateFormatSpecifier);
      const dateFormatParser = d3.timeParse(dateFormatSpecifier);

      const events = {}
      data.forEach(d => {
        d.created = dateFormatParser(d.created_at);
        d.closed = dateFormatParser(d.closed_at);
        d.logged = dateFormatParser(d.date_logged);
        //d.month = d3.timeMonth(d.dd);

        events[d.url] = [{"date" : d.created, "type": "opened", "title": d.title}]
        // events.push({"date" : d.created, "type": "open", "url": d.url})
        if (d.state == "closed") {
          //d.events.push({"date" : d.closed, "type": "close", "url": d.url})
          events[d.url].push({"date" : d.closed, "type": "closed", "title": d.title})
        }
      });

      const ndx = crossfilter(data);
      const all = ndx.groupAll();

/*
      const quarter = ndx.dimension(d => {
        const createdMonth = d.dd.getMonth();
        if (createdMonth <= 2) {
            return 'Q1';
        } else if (createdMonth > 2 && createdMonth <= 5) {
            return 'Q2';
        } else if (createdMonth > 5 && createdMonth <= 8) {
            return 'Q3';
        } else {
            return 'Q4';
        }
      });
      const quarterGroup = quarter.group();*/

      const createdDateDimension = ndx.dimension(d => d.created);

      const issueType = ndx.dimension(d => d.type);
      const issueTypeGroup = issueType.group();
      //const issueStage = ndx.dimension(d => d.stage);
      const issueStage = ndx.dimension(function(d) {return d.stage;});
      const issueStageGroup = issueStage.group();

      const issueState = ndx.dimension(function(d) {return d.state;});
      const issueStateGroup = issueState.group();

      const scheduledType = ndx.dimension(function(d) {return d.scheduled;});
      const scheduledTypeGroup = scheduledType.group();

      const cycleTimeCreatedGroup = ndx.groupAll().reduce(
        // add
        function (p, v) {
          ++p.count;
          p.total += v.cycle_time_created;
          return p;
        },

        function reduceRemove(p, v) {
          --p.count;
          p.total -= v.cycle_time_created;
          return p;
        },

        function reduceInitial() {
          return {count: 0, total: 0};
        });

       var average_cycletimecreated = function(p) { return p.count > 0 ? p.total / p.count : 0; };

       const cycleTimeLoggedGroup = ndx.groupAll().reduce(
        // add
        function (p, v) {
          ++p.count;
          p.total += v.cycle_time_logged;
          return p;
        },

        function reduceRemove(p, v) {
          --p.count;
          p.total -= v.cycle_time_logged;
          return p;
        },

        function reduceInitial() {
          return {count: 0, total: 0};
        });

       var average_cycletimelogged = function(p) { return p.count > 0 ? p.total / p.count : 0; };
/**
       const burndownDimension = ndx.dimension(function(d) {return events[d.url];});
       const burndownDimensionGroup = burndownDimension.group().reduce(
        // add
        function reduceAdd(p, v) {
          console.log(v)
          ++p.count;
          p.open += v.type == "closed" ? -1 : +1;
          return p;
        },

        function reduceRemove(p, v) {
          --p.count;
          p.open += v.type == "closed" ? -1 : +1;
          return p;
        },

        function reduceInitial() {
          return {count: 0, open: 0};
        });

       var open_issues = function(p) { console.log(p); return p.value.open ? p.value.open : 0; };
       dc.lineChart("#burndown-chart")
        .width(768)
        .height(180)
        .x(d3.scaleTime())
        .margins({left: 50, top: 0, right: 0, bottom: 20})
        .elasticY(true)
        .elasticX(true)
        .dimension(burndownDimension)
        .group(burndownDimensionGroup)
        .valueAccessor(open_issues)
**/
      createdDayDimension = ndx.dimension(function (d) {return  d3.timeDay(d.created)});
      createdDayGroup = createdDayDimension.group();
      closedDayDimension = ndx.dimension(function (d) {return d.closed ? d3.timeDay(d.closed) : null});
      closedDayGroup = closedDayDimension.group();
      loggedDayDimension = ndx.dimension(function (d) {return d.logged ? d3.timeDay(d.logged) : null});
      loggedDayGroup = loggedDayDimension.group();

      var timelineChart = new dc.CompositeChart("#timeline-chart");

      var loggedChart = new dc.BarChart(timelineChart)
            .dimension(loggedDayDimension)
            .group(loggedDayGroup)
            .ordinalColors(['#60cf0e'])

      var createdChart = new dc.BarChart(timelineChart)
            .dimension(createdDayDimension)
            .group(createdDayGroup)
            .ordinalColors(['#60A4D0']);

      var closedChart = new dc.BarChart(timelineChart)
            .dimension(closedDayDimension)
            .group(closedDayGroup)
            .ordinalColors(['#cf160e'])

      timelineChart
        .width(1200)
        .height(180)
        .x(d3.scaleTime())
        .xUnits(d3.timeWeeks)
        .round(d3.timeWeek.round)
        .brushOn(true)
        .margins({left: 50, top: 0, right: 0, bottom: 20})
        .elasticY(true)
        .elasticX(true)
        .compose([
          loggedChart,
          createdChart,
          closedChart
        ]);

      dc.pieChart('#state-chart')
        .width(180)
        .height(180)
        .radius(80)
        .innerRadius(30)
        .dimension(issueState)
        .group(issueStateGroup);

      dc.pieChart('#type-chart')
        .width(180)
        .height(180)
        .radius(80)
        .innerRadius(30)
        .dimension(issueType)
        .group(issueTypeGroup)
        .ordinalColors(['#6bd50a', '#d5180a']);

      dc.pieChart('#scheduled-chart')
        .width(180)
        .height(180)
        .radius(80)
        .innerRadius(30)
        .dimension(scheduledType)
        .group(scheduledTypeGroup)
        .ordinalColors(['#6bd50a', '#d5180a']);

      dc.rowChart('#stage-chart')
        .width(250)
        .height(180)
        .dimension(issueStage)
        .group(issueStageGroup)
        .elasticX(true)
        .xAxis().ticks(4);

      dc.numberDisplay("#cycle-time-opened")
        .formatNumber(d3.format(".3s"))
        .valueAccessor(average_cycletimecreated)
        .group(cycleTimeCreatedGroup)

      dc.numberDisplay("#cycle-time-logged")
        .formatNumber(d3.format(".3s"))
        .valueAccessor(average_cycletimelogged)
        .group(cycleTimeLoggedGroup)

      

      dc.dataCount('#record-count')
        .crossfilter(ndx)
        .groupAll(all)
        .html({
            some: '<strong>%filter-count</strong> selected out of <strong>%total-count</strong> issues' +
                ' | <a href=\'javascript:dc.filterAll(); dc.renderAll();\'>Reset All</a>',
            all: 'All issues selected. Please click on the graph to apply filters.'
        });


      dc.dataTable('#issue-table')
        .dimension(issueType)
        .columns([
          {
           label: "Title",
           format: function (d) {
              return '<a href="' + d.url + '">' + d.title +'</a>';}
          },'type','stage','milestone','notes','created_at','date_logged','closed_at'])
        .sortBy(d => d.dd)
        .order(d3.ascending)
        .showSections(false);

      dc.renderAll();
    });
  </script>
</head>
<body>

<div id="heading" class="container-fluid text-white" style="background-color: #292961">
    <h2><img style="height: 58px" src="assets/gitlab-logo-white-rgb.svg"/>${customer_project} issues report - ${startdate} to ${enddate}</h2>
  <ul class="nav nav-tabs">
  <li class="nav-item">
    <a class="nav-link" href="./index.html" style="background-color: #AAAAAA">Overview</a>
  </li>
  <li class="nav-item">
    <a class="nav-link active" href="#">Statistics</a>
  </li>
  </ul>
</div>

<div class="container-fluid">
  <div class="row">
    <div id='state-chart' class="dc-chart"><h4>State</h4></div>
    <div id='type-chart' class="dc-chart"><h4>Type</h4></div>
    <div id='scheduled-chart' class="dc-chart"><h4>Scheduled</h4></div>
    <div id='stage-chart' class="dc-chart"><h4>Stage</h4></div>
    <div style="margin:10px">
      <h5>Avg cycle time (opened)</h5>
      <div id='cycle-time-opened' class="dc-chart"></div>
    </div>
    <div style="margin:10px">
      <h5>Avg cycle time (logged)</h5>
      <div id='cycle-time-logged' class="dc-chart"></div>
    </div>
    

  </div>
  <div class="row">
    <!--<div id='burndown-chart' class="dc-chart"><h4>Burndown</h4></div>-->
    <div id='timeline-chart' class="dc-chart"><h4>Timeline</h4></div>
  </div>
  <div class="row">
    <div id='record-count'></div>
    <table id='issue-table' class="table table-striped dc-chart"></table>
  </div>
</div>

</body>
</html>

